#include <asm/unistd.h>

.global _start
_start:
	popl	%ecx			// argc
	incl	%ecx			// +1
	movl	%esp,%eax		// (char**)argv
	leal	(%esp,%ecx,4),%ebx	// (char**)envp
	decl	%ecx			// -1
	pushl	%ebx
	pushl	%eax
	pushl	%ecx
	push	$0			// return pointer
	jmp	main

.global getpgid
getpgid:
	push	$__NR_getpgid
	jmp	k_entry_edx

.global sethostname
sethostname:
	push	$__NR_sethostname
	jmp	k_entry_edx

.global setdomainname
setdomainname:
	push	$__NR_setdomainname
	jmp	k_entry_edx

.global waitpid
waitpid:
	push	$__NR_waitpid
	jmp	k_entry_edx

.global read
read:
	push	$__NR_read
	jmp	k_entry_edx

.global write
write:
	push	$__NR_write
	jmp	k_entry_edx

.global open
open:
	push	$__NR_open
	jmp	k_entry_edx

.global close
close:
	push	$__NR_close
	jmp	k_entry_edx

.global signal
signal:
	push	$__NR_signal
	// fall through

k_entry_edx:
	popl	%eax
	pushl	%ebx
	movl	16(%esp),%edx
	movl	12(%esp),%ecx
	movl	8(%esp),%ebx
	int	$0x80
	popl	%ebx
	ret

.global pause
pause:
	push	$__NR_pause
	jmp	k_entry

.global fork
fork:
	push	$__NR_fork
	// fall through

k_entry:
	popl	%eax
	int	$0x80
	ret

.global execve
execve:
	pushl	%ebx
	movl	16(%esp),%edx
	movl	12(%esp),%ecx
	movl	8(%esp),%ebx
	push	$__NR_execve
	popl	%eax
	int	$0x80
	// fall through to exit
	// right now we ignore errors and just die

.global	exit
exit:
	popl	%eax	// discard
	popl	%ebx	// exit arg
quick_exit:
	xorl	%eax,%eax
	incl	%eax
	int	$0x80
	// if we return from exit we might aswell do an uncontrolled crash

.global chop
chop:
	movl	4(%esp),%eax
chop.A0:
	movb	(%eax),%cl
	xorb	$'\n',%cl
	je	chop.A1
	incl	%eax
	or	%cl,%cl
	jnz	chop.A0
	ret
chop.A1:
	movb	%cl,(%eax)
	ret

.global str_confpath
str_confpath:
	.string	"/etc/init/"
	.byte	0

.global str_autoopt
str_autoopt:
	.string	"auto"
	.byte	0

.global str_spawn
str_spawn:
	.string	"spawn"
	.byte	0

.global str_hostname
str_hostname:
	.string "hostname"
	.byte	0

.global str_domainname
str_domainname:
	.string "domainname"
	.byte	0

.global	bannerfmt
bannerfmt:
	.string	"INIT: twsinit version 0.1 booting (%s)\n"
	.byte	0

#ifdef VERBOSE

.global respawnfmt
respawnfmt:
	.string	"INIT: respawn `%s' [job %i: `%s'] = pid %i\n"
	.byte	0

#endif /* VERBOSE */

.global nullstr
nullstr:
	.string	"(null)"
	.byte	0

.global num
num:
	.long	0x3b9aca00, 0x05f5e100, 0x00989680, 0x000f4240, 0x000186a0
	.long	0x00002710, 0x000003e8, 0x00000064, 0x0000000a, 0x00000000

